%%%%% COMPUTE HESSIAN H  %%%%%%%%%%


par.H=zeros(n);
for j=1:n
    ap=a0; am=a0;
    ap(j)=a0(j)+0.001; am(j)=a0(j)-0.001;
    [time,Yp]=makeY(ap,x0,par);
    [time,Ym]=makeY(am,x0,par);
    if ny==1 %1 output        
        drdth(:,j)=(Yp(2:end,1)-Ym(2:end,1))/(ap(j)-am(j))./sig(2:end,1);
    else % concatenate ny outputs
        dr=(Yp(2:end,1)-Ym(2:end,1))/(ap(j)-am(j))./sig(2:end,1);
        for jout=2:ny
            dr=[dr; (Yp(2:end,jout)-Ym(2:end,jout))/(ap(j)-am(j))./sig(2:end,jout)]; %%!sig
        end
        drdth(:,j)=dr;
    end
end

par.H=2*drdth'*drdth;

if model==1
    %%% compute H in linear space
    for j=1:n
        ap=10.^a0; am=ap; 
        ap(j)=ap(j)*(1.001); am(j)=am(j)*(1-0.001);
        [time,Yp]=makeY(log10(ap),x0,par);
        [time,Ym]=makeY(log10(am),x0,par);
        drdth(:,j)=(Yp(2:end,1)-Ym(2:end,1))/(ap(j)-am(j))./sig(2:end,1);
    end
    par.H=2*drdth'*drdth;
end

clear drdth

