function [time Y]=makeY(a,x0,par)

td=par.td;

warning off
[time,Y]=ode15s('functionf',td,x0,[],a,par);

if isreal(Y)==0
    disp('imaginary solution')
    Y=real(Y);
end

%% we consider only values within [1e-6,1e6]:
Y=max(1e-6,Y); Y=min(1e6,Y); 

